function fit_contractility(pth)
%
% plot the contraction of networks
% 
% Example:
% fit_contractility('run*');
%
% F.Nedelec 23.08.2017

font = 14;

if nargin > 0
   cdir = pwd;
   cd(pth);
else
   pth = pwd;
   cdir = '.';
end

try
    get_interval;
    fprintf(1, 'interval = %f\n', interval);
catch
    interval = 1;
end


% generated by 'get_contraction.py run* > data.txt'
data = load('data.txt');
% use first column after 'nan' as reference size
inx0 = find_nan(data(1,:)) + 1;

% find a suitable xdata:
xdata = data(:,2);
if max(xdata) == min(xdata)
    xdata = data(:,3);
end

% contraction is the difference between first and second column
inx1 = inx0 + 1;
inx2 = inx1 + 1;
delta_time = ( inx2 - inx1 ) * interval;
drad = ( sqrt(2*data(:,inx2))-sqrt(2*data(:,inx1)) ) / delta_time;


h = figure('Position', [512, 512, 512+128, 512+128]);
h.Name = pth;
h.Color = 'white';

subplot('Position', [0.1 0.13 0.85 0.6]);
hold on;
fit_theory(xdata, drad);
plot(xdata, drad, 'b.', 'MarkerSize', 12);
%plot([0 xx], [0, 0], 'k:');

ax = gca;
ax.FontSize = font;
ax.XAxis.Exponent = 0;
ax.YLim = [ax.YLim(1), 0];

info = read_info();
xlabel(info, 'FontSize', 18, 'Interpreter', 'None');
ylabel('dR/dt     [\mum/s]', 'FontSize', 18);

h = legend('Simulations', 'Theory');
h.Location = 'north';
h.FontSize = 14;

subplot('Position', [0.1 0.75 0.85 0.2]);
plot_coefficients(xdata)

cd(cdir);
savepng('contract');
end

%%
function x = find_nan(data)
    x = 1;
    while ~isnan(data(x)) && x < length(data)
        x = x + 1;
    end
end

function res = read_info()
    res = {'unknown', ''};
    f = fopen('xlabel.txt');
    if f > 0
        str = fgets(f);
        if str > 0 
            res{1} = str(1:end-1);
        end
        str = fgets(f);
        if str > 0 
            res{2} = str(1:end-1);
        end
    end
end


function plot_coefficients(xdata)
    try
        T = load('theory.txt');
    catch
        return
    end
    [XX, I] = sort(xdata);
    pM = T(I,3);
    pC = T(I,4);
    
    plot(XX, pC, 'b-', 'LineWidth', 3);
    hold on
    plot(XX, pM, 'r-', 'LineWidth', 3);

    xlim([0, max(xdata)]);
    ylim([0,1]);

    set(gca, 'XTick', []);
    h = legend('P_C', 'P_M');
    h.Location = 'northwest';
    h.FontSize = 14;
end


function [err, fit, sca] = fit_one(YY, fun)
    sca = sum( YY.*fun ) / sum( fun.^2 );
    fit = sca * fun;
    err = sum( ( YY - fit ).^2 );
end


function [err, fit, sca1, sca2] = fit_two(YY, f1, f2)
    M = [ sum(f1.*f2), sum(f2.^2); sum(f1.^2), sum(f1.*f2) ];
    V = M \ [ sum(YY.*f2); sum(YY.*f1) ];
    sca1 = V(1);
    sca2 = V(2);
    fit = sca1 * f1 + sca2 * f2;
    err = sum( ( YY - fit ).^2 );
end


function msg = fit_theory(xdata, ydata)
    
    [XX, I] = sort(xdata);
    YY = ydata(I);

    try
        T = load('theory.txt');
        msg = '';
    catch
        msg = 'missing file theory.txt';
        return
    end
    
    pM = T(I,3);
    pC = T(I,4);
    
    if any( pM > 1 ) || any( pC > 1 )
        error('unconsistent data: probabilities should be <= 1');
    end

    % One component fit:
    msg{1} = 'P_M P_C (1-P_C)^\beta';
    best_beta = 10;
    fun = pM.*pC.*(1-pC).^best_beta;
    [best_err, best_fit] = fit_one(YY, fun);
    % this will discard any other fit:
    best_err = 0;
    
    % scan through beta
    for beta = 9.0:0.01:11
        fun = pM.*pC.*(1-pC).^beta;
        [err, fit] = fit_one(YY, fun);
        plot(XX, fit, ':', 'color', [0.75 0.75 0.75], 'LineWidth', 1);
        if ( err < best_err )
            best_fit = fit;
            best_err = err;
            best_beta = beta;
        end
    end
    
    fprintf(1, 'one_fit error %f with %s\n', best_err, msg{1});
    fprintf(1, 'beta = %f\n', best_beta);
    plot(XX, best_fit, 'k-', 'LineWidth', 2);

    msg{2} = ['\beta = ', num2str(best_beta)];
    
end

